//+------------------------------------------------------------------+
//|                                               iOptionsLevels.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "*"
#property link      "*"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 C'None'

#define SD 4

/*
Path -      csv.      experts/files
Symb -  (  ),     ( EURUSD),      -    .      ( EURUSD_EX, EURUSDmin,  ..)
DaysCount -   . -1 -   
MinVolume -    
CallColor -  Call
PutColor -  Put
LineSize -  
TodayLineSize -   
Labels -  
TextSize -   
BarsForLabel -     
ShowFromTimeFrme -   
ShowToTimeFrme -   
*/

//---- input parameters
extern   string   Path              =  "OptionsLevels";  //      csv.      experts/files
extern   string   Symb              =  "";               //  (  ),     ( EURUSD),      -    .      ( EURUSD_EX, EURUSDmin,  ..)
extern   int      DaysCount         =  5;               //   . -1 -   
extern   int      MinVolume         =  0;                //    
extern   color    CallColor         =  Red;              //  Call
extern   color    PutColor          =  DodgerBlue;       //  Put
extern   int      LineSize          =  1;                //  
extern   int      TodayLineSize     =  3;                //   
extern   bool     Labels            =  true;             //  
extern   int      TextSize          =  7;                //   
extern   int      BarsForLabel      =  12;               //     
extern   int      ShowFromTimeFrme  =  5;                //   
extern   int      ShowToTimeFrme    =  60;               //   

int LabelVShift=0; //      

//---- buffers
double ExtMapBuffer1[];


double CallData[][SD];
double PutData[][SD];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){

   //if(MinVolume!=0)Alert("      ");

   Path=StringTrimLeft(StringTrimRight(Path));
      if(Path!=""){
         if(StringSubstr(Path,StringLen(Path)-1,1)!="/" && StringSubstr(Path,StringLen(Path)-1,1)!="\\"){
            Path=Path+"\\";
         }
      }

   Symb=StringTrimLeft(StringTrimRight(Symb));
   if(Symb=="")Symb=Symbol();

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);

   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   fObjDeleteByPrefix(WindowExpertName());
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
      
      static bool ft=false;
      
         if(!ft){
            ArrayResize(CallData,0);
            ArrayResize(PutData,0);
            datetime date;
            date=TimeCurrent();
            date/=86400;
            date*=86400;
            int dk=0;
               while(date>=Time[Bars-1] && (dk<DaysCount || DaysCount==-1)){
                  string FileName=Path+Symb+"_"+TimeYear(date)+"."+F(TimeMonth(date))+"."+F(TimeDay(date))+".csv";
                  int h=FileOpen(FileName,FILE_CSV|FILE_READ|FILE_WRITE,"|");
                     if(h!=-1){
                        if(FileSize(h)==0){
                           FileClose(h);
                           FileDelete(FileName);
                        }
                        else{                        
                              while(!FileIsEnding(h)){
                                 string str=FileReadString(h);
                                 str=StringTrimLeft(StringTrimRight(str));
                                    if(str!=""){
                                       string tmp[];
                                       fStrSplit(str,tmp,";");
                                          for(int i=0;i<ArraySize(tmp);i++){
                                             tmp[i]=StringTrimLeft(StringTrimRight(tmp[i]));
                                          }
                                          if(tmp[0]!=""){
                                             if(StrToDouble(tmp[0])>=MinVolume){
                                                ArrayResize(CallData,ArraySize(CallData)/SD+1);
                                                CallData[ArraySize(CallData)/SD-1][0]=date;
                                                CallData[ArraySize(CallData)/SD-1][1]=StrToDouble(tmp[4])+StrToDouble(tmp[2]);
                                                CallData[ArraySize(CallData)/SD-1][2]=StrToDouble(tmp[0]);
                                                CallData[ArraySize(CallData)/SD-1][3]=StrToDouble(tmp[1]);
                                             }
                                          }
                                          if(tmp[8]!=""){ 
                                             if(StrToDouble(tmp[8])>=MinVolume){
                                                ArrayResize(PutData,ArraySize(PutData)/SD+1);
                                                PutData[ArraySize(PutData)/SD-1][0]=date;
                                                PutData[ArraySize(PutData)/SD-1][1]=StrToDouble(tmp[4])+StrToDouble(tmp[6]);
                                                PutData[ArraySize(PutData)/SD-1][2]=StrToDouble(tmp[8]);
                                                PutData[ArraySize(PutData)/SD-1][3]=StrToDouble(tmp[7]);
                                             }
                                          }                                          
                                          
                                    }
                              }
                           FileClose(h);
                        }
                     }
                  date-=86400;
                  dk++;
               }
            ft=true;   
         }

         
         if(Period()>=ShowFromTimeFrme && Period()<=ShowToTimeFrme){
            date=TimeCurrent();
            date/=86400;
            date*=86400;
               for(i=0;i<ArraySize(CallData)/SD;i++){
                  datetime LeftTime=CallData[i][0];
                  datetime RightTime=CallData[i][0]+86400-Period()*60;
                  int lbs=iBarShift(Symbol(),Period(),LeftTime,true);
                  if(lbs==-1)lbs=iBarShift(Symbol(),Period(),LeftTime,false)-1;
                  LeftTime=fMyTime(lbs);
                  int rbs;
                     if(RightTime>Time[0]){
                        rbs=-(RightTime-Time[0])/(Period()*60);
                     }
                     else{
                        rbs=iBarShift(Symbol(),Period(),RightTime,false);
                     }
                     if(Labels){
                        rbs+=BarsForLabel;
                        int tbs=rbs-BarsForLabel/2;
                        datetime LabelTime=fMyTime(tbs);
                        fObjText(WindowExpertName()+"_CallTxt_"+i,LabelTime,CallData[i][1]+Point*LabelVShift,DS0(CallData[i][2])+" ("+DS0(CallData[i][3])+")",CallColor,TextSize,0,"Arial",false);
                     }
                  RightTime=fMyTime(rbs);
                     if(RightTime>LeftTime){
                        int size=LineSize;
                        if(date==CallData[i][0])size=TodayLineSize;
                        fObjTrendLine(WindowExpertName()+"_Call_"+i,LeftTime,CallData[i][1],RightTime,CallData[i][1],false,CallColor,size,0,0,true);
                        ObjectSetText(WindowExpertName()+"_Call_"+i,DS0(CallData[i][2])+" ("+DS0(CallData[i][3])+")");
                     }
               }
         
               for(i=0;i<ArraySize(PutData)/SD;i++){
                  LeftTime=PutData[i][0];
                  RightTime=PutData[i][0]+86400-Period()*60;
                  lbs=iBarShift(Symbol(),Period(),LeftTime,true);
                  if(lbs==-1)lbs=iBarShift(Symbol(),Period(),LeftTime,false)-1;
                  LeftTime=fMyTime(lbs);
                     if(RightTime>Time[0]){
                        rbs=-(RightTime-Time[0])/(Period()*60);
                     }
                     else{
                        rbs=iBarShift(Symbol(),Period(),RightTime,false);
                     }
                     if(Labels){
                        rbs+=BarsForLabel;
                        tbs=rbs-BarsForLabel/2;
                        LabelTime=fMyTime(tbs);
                        fObjText(WindowExpertName()+"_PutTxt_"+i,LabelTime,PutData[i][1]+Point*LabelVShift,DS0(PutData[i][2])+" ("+DS0(PutData[i][3])+")",PutColor,TextSize,0,"Arial",false);
                     }               
                  RightTime=fMyTime(rbs);
                     if(RightTime>LeftTime){
                        size=LineSize;
                        if(date==PutData[i][0])size=TodayLineSize;                     
                        fObjTrendLine(WindowExpertName()+"_Put_"+i,LeftTime,PutData[i][1],RightTime,PutData[i][1],false,PutColor,size,0,0,true);
                        ObjectSetText(WindowExpertName()+"_Put_"+i,DS0(PutData[i][2])+" ("+DS0(PutData[i][3])+")");
                     }
               }
         }         

   return(0);
}
//+------------------------------------------------------------------+

void fObjText(
   string aObjectName,     // 1 
   datetime aTime_1,       // 2 
   double aPrice_1,        // 3 
   string aText,           // 4 
   color aColor=Red,       // 5 
   int aFontSize=8,        // 6  
   int aWindowNumber=0,    // 7 
   string aFont="Arial",   // 8 
   bool aBack=false        // 9 
   ){
      if(ObjectFind(aObjectName)!=aWindowNumber){
         ObjectCreate(aObjectName,OBJ_TEXT,aWindowNumber,aTime_1,aPrice_1);
      }      
   ObjectSet(aObjectName,OBJPROP_TIME1,aTime_1);
   ObjectSet(aObjectName,OBJPROP_PRICE1,aPrice_1);   
   ObjectSetText(aObjectName,aText,aFontSize,aFont,aColor);
   ObjectSet(aObjectName,OBJPROP_BACK,aBack);
}


string DS0(double v){return(DoubleToStr(v,0));}


int fMyTime(int aShift){
      if(aShift<0){
         return(Time[0]+Period()*60*MathAbs(aShift));
      }
   return(Time[aShift]);
}


void fObjTrendLine(
   string aObjectName,  // 1 
   datetime aTime_1,    // 2  1
   double aPrice_1,     // 3  1
   datetime aTime_2,    // 4  2
   double aPrice_2,     // 5  2
   bool aRay=false,     // 6 
   color aColor=Red,    // 7 
   int aWidth=1,        // 8 
   int aWindowNumber=0, // 9 
   int aStyle=0,        // 10 0-STYLE_SOLID, 1-STYLE_DASH, 2-STYLE_DOT, 3-STYLE_DASHDOT, 4-STYLE_DASHDOTDOT
   bool aBack=false     // 11 
   ){
      if(ObjectFind(aObjectName)!=aWindowNumber){
         ObjectCreate(aObjectName,OBJ_TREND,aWindowNumber,aTime_1,aPrice_1,aTime_2,aPrice_2);
      }      
   ObjectSet(aObjectName,OBJPROP_TIME1,aTime_1);
   ObjectSet(aObjectName,OBJPROP_PRICE1,aPrice_1);   
   ObjectSet(aObjectName,OBJPROP_TIME2,aTime_2);       
   ObjectSet(aObjectName,OBJPROP_PRICE2,aPrice_2); 
   ObjectSet(aObjectName,OBJPROP_RAY,aRay);     
   ObjectSet(aObjectName,OBJPROP_COLOR,aColor);
   ObjectSet(aObjectName,OBJPROP_WIDTH,aWidth);
   ObjectSet(aObjectName,OBJPROP_BACK,aBack);
   ObjectSet(aObjectName,OBJPROP_STYLE,aStyle);                
}


string F(int A){
   if(A<10)return("0"+A);
   return(A);
}

void fStrSplit(string aString,string & aArray[],string aDelimiter){
   int tCounter=0;
   int tDelimiterLength=StringLen(aDelimiter);
   ArrayResize(aArray,tCounter);
   int tPos1=0;
   int tPos2=StringFind(aString,aDelimiter,0);
      while(tPos2!=-1){
            if(tPos2>=tPos1){
               tCounter++;
               ArrayResize(aArray,tCounter);
                  if(tPos2-tPos1==0){
                     aArray[tCounter-1]="";
                  }
                  else{
                     aArray[tCounter-1]=StringSubstr(aString,tPos1,tPos2-tPos1);
                  }
            }
         tPos1=tPos2+tDelimiterLength;
         tPos2=StringFind(aString,aDelimiter,tPos1);
      }
   tPos2=StringLen(aString);      
      if(tPos2>=tPos1){
         tCounter++;   
         ArrayResize(aArray,tCounter);
            if(tPos2-tPos1==0){
               aArray[tCounter-1]="";
            }
            else{
               aArray[tCounter-1]=StringSubstr(aString,tPos1,tPos2-tPos1);      
            }
      }
}

void fObjDeleteByPrefix(string aPrefix){
   for(int i=ObjectsTotal()-1;i>=0;i--){
      if(StringFind(ObjectName(i),aPrefix,0)==0){
         ObjectDelete(ObjectName(i));
      }
   }
}


